﻿/*
 * Created by SharpDevelop.
 * User: Tomaj Vadasz
 * Date: 10/20/2010
 * Time: 11:27 PM
 * 
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 */
using System;
using System.Collections.Generic;
using System.Drawing;
using System.Windows.Forms;

namespace Arduicu
{
	/// <summary>
	/// Description of MainForm.
	/// </summary>
	public partial class MainForm : Form
	{
		public const byte ECU_OK = 1;
		public const byte ECU_WAITING = 254;
		public const byte ECU_NOT_READY= 255;
		public const byte ECU_RECEIVE_EOM = 06;
		public const byte ECU_SEND_EOM = 04;
		
		public MainForm()
		{
			//
			// The InitializeComponent() call is required for Windows Forms designer support.
			//
			InitializeComponent();
			
			//
			// TODO: Add constructor code after the InitializeComponent() call.
			//
			
			this.cmbComPort.Items.AddRange(System.IO.Ports.SerialPort.GetPortNames());
		}
		
		
		
		void BtnConnectClick(object sender, EventArgs e)
		{
			try {
				this.serialPort1.PortName = this.cmbComPort.Text;
				this.serialPort1.BaudRate = int.Parse(this.cmbBaudRate.Text);
				this.serialPort1.Open();
				this.grpMain.Enabled = true;
			}
			catch (Exception ex)
			{
				MessageBox.Show("Error connecting:\n\n" + ex.Message);
			}
		}
		
		void BtnGetStatusClick(object sender, EventArgs e)
		{
			byte[] bytes = new byte[] {05};
			
			this.serialPort1.Write(bytes,0,1);
			byte response = (byte) this.serialPort1.ReadByte();
			
			string status = "";
			
			switch (response)
			{
				case ECU_OK:
					status = "OK";
					break;
				case ECU_WAITING:
					status = "Awaiting Start";
					break;
				case ECU_NOT_READY:
					status = "ECU not ready for engine";
					break;
			}
			
			this.btnGetStatus.Text = status;
		}
		
		void BtnGetAllDataClick(object sender, EventArgs e)
		{
			byte[] bytes = new byte[] {33,63,65,04};
			
			this.serialPort1.Write(bytes,0,4);
						
			System.Collections.Generic.List<Byte> data = new System.Collections.Generic.List<Byte>();
			byte response;
			
			do
			{
				response = (byte) this.serialPort1.ReadByte();
				
				data.Add(response);
				
			} while (response != ECU_RECEIVE_EOM);
			
			string z = "";
			
			for (int x = 0; x < data.Count; x++)
			{
				z = z + " " + data[x].ToString();
			}
		}
		
		
		void BtnSendMaxRPMClick(object sender, EventArgs e)
		{
			byte[] bytes = BitConverter.GetBytes(UInt32.Parse(this.txtMaxRPM.Text));
			
			byte[] prefix = new byte[] {33,83,76};
			byte[] suffix = new Byte[] {ECU_SEND_EOM};
			
			this.serialPort1.Write(prefix,0,3);
			this.serialPort1.Write(bytes,0,bytes.Length);
			this.serialPort1.Write(suffix,0,1);
		}
		
		
		void BtnSendTimingAdvanceClick(object sender, EventArgs e)
		{
			byte[] bytes = BitConverter.GetBytes(int.Parse(this.txtTimingAdvance.Text));
			
			byte[] prefix = new byte[] {33,83,65};
			byte[] suffix = new Byte[] {ECU_SEND_EOM};
			
			this.serialPort1.Write(prefix,0,3);
			this.serialPort1.Write(bytes,0,bytes.Length);
			this.serialPort1.Write(suffix,0,1);
		}
		
		void BtnInjectorOpenDeltaClick(object sender, EventArgs e)
		{
			byte[] bytes = BitConverter.GetBytes(int.Parse(this.txtInjectorOpenDelta.Text));
			
			byte[] prefix = new byte[] {33,83,77};
			byte[] suffix = new Byte[] {ECU_SEND_EOM};
			
			this.serialPort1.Write(prefix,0,3);
			this.serialPort1.Write(bytes,0,bytes.Length);
			this.serialPort1.Write(suffix,0,1);
		}
		
		void BtnSendCoilDwellTimeClick(object sender, EventArgs e)
		{
			byte[] bytes = BitConverter.GetBytes(UInt32.Parse(this.txtDwell.Text));
			
			byte[] prefix = new byte[] {33,83,68};
			byte[] suffix = new Byte[] {ECU_SEND_EOM};
			
			this.serialPort1.Write(prefix,0,3);
			this.serialPort1.Write(bytes,0,bytes.Length);
			this.serialPort1.Write(suffix,0,1);			
		}
	}
}
